<?php
/**
 * Created by PhpStorm.
 * User: qiuzijian
 * Date: 6/22/24
 * Time: 12:32 PM
 */

namespace Modules\Admin\Http\Controllers\Api;

use App\Enum\ApiEnum;
use App\Http\Controllers\Api\BaseController;
use App\Http\Controllers\Controller;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Input;
use Modules\Admin\Entities\User;
use Modules\Admin\Http\Requests\TokenRequest;
use Modules\Admin\Services\ApiService;
use Modules\Staff\Entities\Staff;
use Symfony\Component\HttpFoundation\Response;

class ApiController extends BaseController
{
    //网格化录入
    public function addConition(Request $request)
    {
        $params = Input::get();
        if (!$params) {
            return self::errorResponse(ApiEnum::STATUS_CODE_EMPTY);
        }
        $result = ApiService::addConition($params);
        return self::successResponse($result);
    }

    //网格化人员轨迹查询条件
    public function getQueryConition(Request $request)
    {
        $date = Input::get('date', '');
        if (!$date) {
            return self::errorResponse(ApiEnum::STATUS_CODE_EMPTY);
        }
        $result = ApiService::getQueryConitions($date);
        return self::successResponse($result);
    }

    //网格化人员轨迹
    public function getPersonTravel(Request $request)
    {
        $person_id = Input::get('person_id', '');
        $depart = Input::get('depart', '');
        $date = Input::get('date', '');
        if (!$person_id || !$depart) {
            return self::errorResponse(ApiEnum::STATUS_CODE_EMPTY);
        }
        $result = ApiService::getPersonTravel($person_id, $depart, $date);
        return self::successResponse($result);
    }

    //网格化巡检记录查询条件
    public function getResultConition()
    {
        $result = ApiService::getResultConition();
        return self::successResponse($result);
    }

    //网格化巡检记录查询
    public function getResultRecord()
    {
        $depart = Input::get('depart', 'all');
        $date_type = Input::get('date_type', 'week');
        $result = ApiService::getResultRecord($depart, $date_type);
        return self::successResponse($result);
    }

    //网格化巡检记录列表
    public function getResultList()
    {
        $person_id = Input::get('person_id', '');
        $depart = Input::get('depart', 'all');
        $date_type = Input::get('date_type', 'week');
        if (!$person_id) {
            return self::errorResponse(ApiEnum::STATUS_CODE_EMPTY);
        }
        $result = ApiService::getResultList($person_id, $depart, $date_type);
        return self::successResponse($result);
    }

    //网格化巡检记录列表明细
    public function getResultDlist()
    {
        $person_id = Input::get('person_id', '');
        $depart = Input::get('depart', '');
        $date = Input::get('date', '');
        if (!$person_id || !$depart || !$date) {
            return self::errorResponse(ApiEnum::STATUS_CODE_EMPTY);
        }
        $result = ApiService::getResultDlist($person_id, $depart, $date);
        return self::successResponse($result);
    }

    //网格化巡检记录明细
    public function getResultDetail()
    {
        $id = Input::get('id', '');
        if (!$id) {
            return self::errorResponse(ApiEnum::STATUS_CODE_EMPTY);
        }
        $result = ApiService::getResultDetails($id);
        return self::successResponse($result);
    }

    //网格化巡检记录
    public function getFinalList()
    {
        $start_date = Input::get('start_date', '');
        $end_date = Input::get('end_date', '');
        $depart = Input::get('depart', '');
        $person = Input::get('person', '');
        if (!$start_date || !$end_date) {
            return self::errorResponse(ApiEnum::STATUS_CODE_EMPTY);
        }
        $result = ApiService::getFinalList($start_date, $end_date, $depart, $person);
        return self::successResponse($result);
    }
}