<?php

use Illuminate\Http\Request;

/*
|--------------------------------------------------------------------------
| API Routes
|--------------------------------------------------------------------------
|
| Here is where you can register API routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| is assigned the "api" middleware group. Enjoy building your API!
|
*/

Route::middleware('auth:api')->get('/admin', function (Request $request) {
    return $request->user();
});

Route::namespace('Api')->group(function () {
    //获取api认证token
    Route::post('oauth/token', 'TokenController@token');
    Route::post('check_token', 'TokenController@checkToken');

    //网格化录入
    Route::post('fanwei/add_conition', 'ApiController@addConition');
    //网格化人员轨迹查询条件
    Route::post('fanwei/get_query_conition', 'ApiController@getQueryConition');
    //网格化人员轨迹
    Route::post('fanwei/get_person_travel', 'ApiController@getPersonTravel');
    //网格化巡检记录查询条件
    Route::post('fanwei/get_result_conition', 'ApiController@getResultConition');
    //网格化巡检记录查询
    Route::post('fanwei/get_result_record', 'ApiController@getResultRecord');
    //网格化巡检记录列表
    Route::post('fanwei/get_result_list', 'ApiController@getResultList');
    //网格化巡检记录列表明细
    Route::post('fanwei/get_result_dlist', 'ApiController@getResultDlist');
    //网格化巡检记录明细
    Route::post('fanwei/get_result_detail', 'ApiController@getResultDetail');
    //网格化巡检记录
    Route::post('fanwei/get_final_list', 'ApiController@getFinalList');
});