<?php

/*
|--------------------------------------------------------------------------
| API Routes
|--------------------------------------------------------------------------
|
| Here is where you can register API routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| is assigned the "api" middleware group. Enjoy building your API!
|
*/

Route::middleware('auth:api')->namespace('Api')->group(function () {
    //视频接口
    Route::post('camera/getlist', 'CameraApiController@getCamerasList');
    Route::post('camera/geturl', 'CameraApiController@getCamerasUrl');
    Route::post('camera/getrtsp', 'CameraApiController@getCamerasRtsp');
    Route::post('camera/transcode', 'CameraApiController@getTranscodeInfo');
    Route::get('camera/stopstream', 'CameraApiController@stopCamerasS tream');
    Route::post('camera/lake/getlist', 'CameraApiController@getSouthLakeCamera');
    Route::post('camera/surface/getlist', 'CameraApiController@getWorkSurfaceCamera');
    Route::post('camera/get_hik_rtsp', 'CameraApiController@getHikRtsp');//海康获取rtsp流
    Route::post('camera/get_hik_rtmp', 'CameraApiController@getHikRtmp');//海康获取rtmp流
    Route::post('camera/playback/getlist', 'CameraApiController@getPlaybackList');//回放时间段列表
    Route::post('camera/playback/geturl', 'CameraApiController@getPlaybackUrl');//回放url
    Route::post('camera/playback/geturleasy', 'CameraApiController@getPlaybackUrlByEasy');//easydrawin回放url
    Route::post('camera/getcamerabytype', 'CameraApiController@getCameraByType');//通过摄像头类型获取所有摄像头
    Route::post('camera/get_lan_url', 'CameraApiController@getCamerasLanUrl');//内网播放url


    //海康视频接口
    Route::get('haikang/monitor/regions/list', 'HaiKangController@getRegionsList');
    Route::get('haikang/monitor/cameras/list', 'HaiKangController@getCamerasList');
    Route::get('haikang/monitor/cameras/url', 'HaiKangController@getCamerasUrl');
    Route::get('haikang/monitor/cameras/transcode', 'HaiKangController@getTranscodeInfo');

    Route::post('testadd', 'CameraApiController@testadd');
    Route::post('testupdate', 'CameraApiController@testupdate');
    Route::get('testdel', 'CameraApiController@testdel');


});

Route::namespace('Api')->group(function () {
    Route::post('camera/upload_img', 'CameraApiController@uploadImg');//图片上传
    Route::post('camera/getcamerabyminecode', 'CameraApiController@getCameraByMinecode');//高风险区域摄像头
    Route::post('camera/picture_base64', 'CameraApiController@pictureBase64');//宁煤存base64图片
    Route::post('camera/get_risk_ningmei', 'CameraApiController@getRiskNingmei');//宁煤高风险摄像头
    Route::post('camera/get_total_ningmei', 'CameraApiController@getTotalNingmei');//宁煤摄像头统计
    Route::post('camera/offline_list', 'CameraApiController@offlineList');//宁煤不在线摄像头列表
    Route::get('camera/get_total_string', 'CameraApiController@getTotalString');//宁煤摄像头统计字符串
    Route::get('test', 'CameraApiController@test');
    Route::post('oss_url','CameraApiController@ossUrl');//文章图片上传至阿里云
    Route::post('article_list','CameraApiController@articleList');//文章列表
    Route::post('duty_information','CameraApiController@dutyInformation');//值班信息
    Route::post('type_list','CameraApiController@typeList');//分类列表
    Route::post('camera_record_insert','CameraApiController@cameraRecordInsert');//摄像托访问记录入库
    Route::post('camera_record_list','CameraApiController@cameraRecordList');//摄像托访问记录列表

    //洗选高风险录入
    Route::post('camera/camera_select', 'CameraApiController@cameraSelect');//摄像头下拉列表
    Route::post('camera/move_camera_select', 'CameraApiController@moveCameraSelect');//移动摄像头下拉列表
    Route::post('camera/zhifa_camera_select', 'CameraApiController@zhifaCameraSelect');//执法记录仪下拉列表
    Route::post('camera/camera_info', 'CameraApiController@cameraInfo');//摄像头信息
    Route::post('camera/readme', 'CameraApiController@readme');//使用说明

    Route::post('task_xixuan/main_home', 'CameraApiController@mainHome');//主屏幕
    Route::post('task_xixuan/risk_work_percent', 'CameraApiController@riskWorkPercent');//风险作业占比
    Route::post('task_xixuan/area_percent', 'CameraApiController@areaPercent');//片区占比
    Route::post('task_xixuan/map_data', 'CameraApiController@mapData');//地图数据
    Route::post('task_xixuan/time_work_count', 'CameraApiController@timeWorkCount');//时间段作业数
    Route::post('task_xixuan/time_area_total', 'CameraApiController@timeAreaTotal');//时间段片区统计
    Route::post('task_xixuan/coal_washery_total', 'CameraApiController@coalWasheryTotal');//洗煤厂统计
    Route::post('task_xixuan/risk_work_list', 'CameraApiController@riskWorkList');//风险作业列表
    Route::post('task_xixuan/risk_work_detail', 'CameraApiController@riskWorkDetail');//风险作业详情
    Route::post('task_xixuan/home', 'CameraApiController@taskHome');//首頁接口
    Route::post('task_xixuan/work_search', 'CameraApiController@workSearch');//首頁作业查询
    Route::post('task_xixuan/area_work_search', 'CameraApiController@areaWorkSearch');//首頁片区作业查询

    Route::post('task_xixuan/main_home_v2', 'CameraApiController@mainHomeV2');//主屏幕
    Route::post('task_xixuan/risk_work_percent_v2', 'CameraApiController@riskWorkPercentV2');//风险作业占比
    Route::post('task_xixuan/area_percent_v2', 'CameraApiController@areaPercentV2');//片区占比
    Route::post('task_xixuan/map_data_v2', 'CameraApiController@mapDataV2');//地图数据
    Route::post('task_xixuan/time_work_count_v2', 'CameraApiController@timeWorkCountV2');//时间段作业数
    Route::post('task_xixuan/time_area_total_v2', 'CameraApiController@timeAreaTotalV2');//时间段片区统计
    Route::post('task_xixuan/coal_washery_total_v2', 'CameraApiController@coalWasheryTotalV2');//洗煤厂统计
    Route::post('task_xixuan/risk_work_list_v2', 'CameraApiController@riskWorkListV2');//风险作业列表
    Route::post('task_xixuan/risk_work_detail_v2', 'CameraApiController@riskWorkDetailV2');//风险作业详情
    Route::post('task_xixuan/home_v2', 'CameraApiController@taskHomeV2');//首頁接口
    Route::post('task_xixuan/work_search_v2', 'CameraApiController@workSearchV2');//首頁作业查询
    Route::post('task_xixuan/area_work_search_v2', 'CameraApiController@areaWorkSearchV2');//首頁片区作业查询

    //大华视频接口
    Route::post('task_xixuan/dahua_camera','TdwyController@dahuaCamera');//大华手动同步
    Route::post('task_xixuan/dahua_talk','CameraApiController@dahuaTalk');//大华语音对讲
    Route::post('task_xixuan/dahua_stop_talk','CameraApiController@dahuaStopTalk');//大华语音对讲
    Route::post('task_xixuan/hik_talk','CameraApiController@hikTalk');//海康语音对讲
});